try:
    from pathlib import Path
    import sqlite3
    import time
    import sys
    from elasticsearch import Elasticsearch, RequestsHttpConnection, exceptions
    from requests_aws4auth import AWS4Auth
    from configparser import ConfigParser
    from v3_database import funcs
    import tldextract
    import traceback
    
    start_time = time.strftime('%Y-%m-%d %H:%M:%S', time.gmtime())

    arg1 = sys.argv[1]
    print(sys.argv)
    source_module = __import__(f'extract.{arg1}.{arg1}',fromlist=['elastic_data_dict'])

    print(str(Path.cwd() / arg1))

    config = ConfigParser()
    config.read(f'extract/{arg1}/elastic_config.ini')

    host = config['elasticSearch']['host']
    region = config['elasticSearch']['region']
    service = config['elasticSearch']['service']
    access_id = config['elasticSearch']['access_id']
    secret_key = config['elasticSearch']['secret_key']
    awsauth = AWS4Auth(access_id, secret_key, region, service)
    index_name = config[f'{arg1}']['source_index']
    es = Elasticsearch(
        hosts = [{'host': host, 'port': 443}],
        http_auth = awsauth,
        use_ssl = True,
        verify_certs = True,
        connection_class = RequestsHttpConnection
    )

    # li = ['https://www.scmp.com/tech/big-tech/article/3107250/samsung-succession-plans-complicated-lee-jae-yongs-risk-jail-time']
    # for url in li:
    #     print(url)
    #     ret  = source_module.elastic_data_dict(url)
    #     if ret != False:
    #         data_dict, ids = ret 
    #         es.index(index = index_name, doc_type = "_doc", body = data_dict, request_timeout = 10, id = ids)
    # exit()

    for c in (Path.cwd() / arg1.split('.')[0]).iterdir():
        # print(str(c / "new_urls.db"))
        connection = sqlite3.connect(str(c / "new_urls.db"),check_same_thread=False,timeout=10)
        cursor = connection.cursor()
        cursor.execute("SELECT url FROM new_urls order by ts desc")
        new_urls = cursor.fetchall()
        print("url count",len(new_urls))
        for url in new_urls:
            print(url[0])        
            print(tldextract.extract(url[0])[1],arg1)
            if tldextract.extract(url[0])[1] == arg1:
                ret = source_module.elastic_data_dict(url[0])
                if ret != False :
                    data_dict, ids = ret 
                    es.index(index = index_name, doc_type = "_doc", body = data_dict, request_timeout = 50, id = ids)
            cursor.execute(f'DELETE FROM new_urls WHERE url="{url[0]}"')
            connection.commit()
            time.sleep(0.3)


    funcs.updateCrawlerStatus(host=config['database']['host'],
                user=config['database']['user'],
                password=config['database']['password'],
                db=config['database']['db'],
                crawler_id=config[f'{arg1}']['id'],
                dev_owner=config[f'{arg1}']['dev_owner'],
                update_user=config['database']['update_user'],
                scheduled_time=start_time,
                scheduled_timezone='GMT',
                active_flag=1,
                crawler_name=config[f'{arg1}']['source_name'])
except Exception as e:
    with open(f'error_sources.txt','a+') as g:
        try:
            g.write(url[0]+'\n')
        except:
            pass
        g.write(arg1+'\n')
        g.write(str(traceback.format_exc())+'\n\n')
        g.write("-"*100)