from bs4 import BeautifulSoup as bs
import requests, re, datetime, pytz, time
from v3_filter import filterv2
from v3_elasticId_gen import elasticId
import traceback
from v3_proxies import proxies
import json
from nested_lookup import nested_lookup
import datetime

def elastic_data_dict(eachLink):
    skipList = ['/showbiz/','/travel/','/entertainment/','/life-style/','/pictures/','/videos/']
    if any(word in eachLink for word in skipList):
        return False
    headers = {
        'dnt': "1",
        'upgrade-insecure-requests': "1",
        'user-agent': "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.111 Safari/537.36",
        'accept': "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9",
        'cache-control': "no-cache"
        }
    res = requests.get(eachLink,headers=headers)
    if res.status_code in [403,500,502]:
        res = proxies.try_proxy(eachLink,headers)
    if res.status_code in [404]:
        return False
    sp = bs(res.content,'html5lib')
    with open(f'economist.txt','wb') as f:
        f.write((eachLink+'\n').encode('utf-8'))
        f.write(res.content)
    jso = sp.find('script',{'id':'__NEXT_DATA__'})
    jso = jso.contents[0]
    jso = json.loads(jso)

    fullarticle = []
    fullarticle = nested_lookup('data', jso['props']['pageProps']['content']['text'])

    headline = jso['props']['pageProps']['metadata']['headline']
    ids = jso['props']['pageProps']['metadata']['articleId']
    authors = jso['props']['pageProps']['metadata']['author']
    timeStamp = jso['props']['pageProps']['metadata']['datePublished']
    fullarticle = []
    fullarticle = nested_lookup('data', jso['props']['pageProps']['content']['text'])

    articleBody = ' '.join(fullarticle)


    ids_hash = elasticId.generate(ids)
    # print(authors)

    try:
        ret = filterv2.filter(articleBody)
    except:
        print("hereis what",eachLink)
        raise Exception(traceback.format_exc())
    if ret == False:
        return False
    
    timeStamp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%dT%H:%M:%SZ%z')
    data_dict = {
          'headline': headline,
          'main_article': articleBody,
          'published_timestamp': timeStamp,
          'source_url': eachLink,
          'source': "South China Morning Post",
          'ISIN': "NULL",
          'sector': ret['sector_list'],
          'category': "NULL",
          'author': authors,
          'stock_symbol': "NULL",
          'debt_listing': ret['debt_listing_list'],
          'id_on_source': ids,
          'sentiment': 'NULL',
          'industry': ret['industry_list'],
          'company_name': ret['company_list'],
          'source_language': "English",
          'entity_id': ret['entity_id_list'],
          'tags': ret['tags'],
          'tags_common': ret['tags_common'],
          'article_desc': '',
          'r': ret['r'],
          'n': ret['n'],
          'ns':ret['ns'],
          'nss': ret['nss'],
          'ta': ret['ta'],
          'country': ret['country'],
          'usd_sales': ret['usd_sales']
        }

    if(len(data_dict["main_article"])>260):
        loc=data_dict["main_article"].find(' ',250,260)
        if(loc!=-1):
            data_dict['article_desc']=data_dict["main_article"][0:loc]
        else:
            data_dict['article_desc']=data_dict["main_article"][0:250]
    else:
        data_dict['article_desc']=data_dict["main_article"]

    return data_dict, ids_hash

# p = elastic_data_dict('https://www.economist.com/prospero/2020/10/28/ife-tells-a-story-of-forbidden-love-in-nigeria')
# print(p)


