from datetime import datetime
import requests
from bs4 import BeautifulSoup as B
from v3_proxies import proxies
import re
from datetime import datetime
from v3_proxies import proxies
from v3_elasticId_gen import elasticId
from v3_filter import filterv2
import traceback

def elastic_data_dict(eachLink):
    if eachLink == 'https://www.forbes.com/sites/kenrickcai/2020/11/12/rise-of-the-recycling-robots/':
        return False
    header={
		'authority':'www.forbes.com',
		'method':'get',
		"sec-fetch-dest":"document",
		'sec-fetch-mode':'navigate',
		'sec-fecth-site':'same-origin',
		"user-agent":'Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.183 Safari/537.36',
		'accept-encoding':'gzip, deflate, br',
		'accept-language':'en-GB,en-US;q=0.9,en;q=0.8',
		"dnt":"1",
		"accept":"*/*"
	}

    res=requests.get(eachLink,headers=header)
    if res.status_code in [403,500,502]:
        res = proxies.try_proxy(eachLink,header)
    if res.status_code in [404]:
        return False

    with open(f'forbes.txt','wb') as f:
        f.write((eachLink+'\n').encode('utf-8'))
        f.write(res.content)

    page=B(res.content,'html5lib')
    category=page.find('meta',{'property':'article:section'})['content']
    category_url=page.find('meta',{'property':'article:section_url'})['content']

    # Checking the article belongs to the section we want 

    del_flag=True
    b=['leadership','shop','forbescoachescouncil','shopping','find','lifestyle','newsletter','consumer','women']
    cat=str(category).lower()
    for x in b:
        if(re.search(x,cat)):
            del_flag=False
            break

    if(del_flag==False):
        print("Skipping "+str(category_url))
        return False

    sub_cat=str(category_url).lower()
    c=['sports','newsletter','policy','paid','taxes','personal','premium','retirement','find','under','life','italia']
    for y in c:
        if(re.search(y,sub_cat)):
            del_flag=False
            break
    if(del_flag==False):
        print("Skipping "+str(category_url))
        return False

    #if true go ahead


    try:
        
        try:
            a=page.find_all('div',{'class':'wp-caption'})
            for pk in a:
                pk.extract()
            
        except:
            pass
        try:
            page.find('img').extract()
        except:
            pass
        body_container=page.find('div',{'class':'article-body'})
        try:
            body_container.find('div',{'class':'article-sharing'}).extract()
        except:
            pass
        try:
            abc=body_container.find_all('figure')
            for tm in abc:
                tm.extract()
        except:
            pass
    
        paras=body_container.find_all('p')
        content=[]
        articleBody=''
        for eachpara in paras:
            ate=eachpara.text
            ate=ate.strip()
            content.append(ate)
        articleBody='\n'.join(content)



        # data_dict['main_article']=org_data

    except :
        print("No data")
        return False

# Getting tags from bodydata

    try:
        ret = filterv2.filter(articleBody)
    except:
        print("hereis what",eachLink)
        raise Exception(traceback.format_exc())
    if ret == False:
        return False

    # Adding all to dictionary

  


    author=page.find('meta',{'property':'article:author'})['content']
    id_on_source=page.find('meta',{'property':'article:id'})['content'].split('/')[-1].split('-')[-1]
    
    try:
        time=''
        header=page.find('div',{'class':'article-headline-container'})
        time=time + str(header.find('time').text) + str(header.find('span',{'class':'time'}).text)
        time=''.join(time.split(' '))
    except:
        timestamp=page.find('meta',{'property':'article:published'})['content']
        timestamp=datetime.strptime(timestamp+"+0000",'%Y-%m-%d%z')
        timestamp=int(timestamp.timestamp())
    # ETC is 5 hrs less than UTC
    timestamp =datetime.strptime(time+'-0500','%b%d,%Y,%I:%M%pEST%z')
    timestamp=int(timestamp.timestamp())
    headline=page.find('meta',{'property':'og:title'})['content']

    ids_hash = elasticId.generate(id_on_source)
    

    data_dict = {
                        "headline":headline,
                        "main_article":articleBody,
                        "published_timestamp":timestamp,
                        "source_url":eachLink,
                        "source" :'Forbes',
                        "ISIN": "NULL",
                        "sector": ret['sector_list'],
                        "category":"NULL",
                        "author" :author,
                        "stock_symbol" : "NULL",
                        "debt_listing" : ret['debt_listing_list'],
                        "id_on_source":id_on_source,
                        "sentiment" : "NULL",
                        "industry" : ret['industry_list'],
                        "company_name" : ret['company_list'],
                        "source_language" : "English",
                        'entity_id': ret['entity_id_list'],
                        'tags': ret['tags'],
                        'tags_common': ret['tags_common'],
                        'article_desc': '',
                        'r': ret['r'],
                        'n': ret['n'],
                        'ns':ret['ns'],
                        'nss': ret['nss'],
                        'ta': ret['ta'],
                        'country': ret['country'],
                        'usd_sales': ret['usd_sales']
                    }

    if(len(data_dict["main_article"])>260):
        loc=data_dict["main_article"].find(' ',250,260)
        if(loc!=-1):
            data_dict['article_desc']=data_dict["main_article"][0:loc]
        else:
            data_dict['article_desc']=data_dict["main_article"][0:250]
    else:
        data_dict['article_desc']=data_dict["main_article"]


    return data_dict,ids_hash
