from bs4 import BeautifulSoup as bs
import requests, json, re, datetime, pytz, time
from v3_filter import filterv2
from v3_elasticId_gen import elasticId
import traceback
from v3_proxies import proxies

def elastic_data_dict(eachLink):
    skipList = ['/photos/','/special-reports/']
    if any(word in eachLink for word in skipList):
        return False
    headers = {
            'dnt': "1",
            'upgrade-insecure-requests': "1",
            'user-agent': "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.111 Safari/537.36",
            'accept': "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9",
            'cache-control': "no-cache"
            }
    res = requests.get(eachLink,headers=headers)
    if res.status_code in [403,500,502]:
        res = proxies.try_proxy(eachLink,headers)
    if res.status_code in [404]:
        return False
    
    with open(f'scmp.txt','wb') as f:
        f.write((eachLink+'\n').encode('utf-8'))
        f.write(res.content)
    sp = bs(res.content, 'html.parser')

    soup = bs(res.content,'html5lib')
    if soup.find('meta',{'name':'cse_type'})['content'] == 'Video':
        return False
    
    final_text =''
    scrpt = soup.find_all("script")

    for i in scrpt:
        if i.find(text=re.compile("window.__APOLLO_STATE__")):
            f_script = i
            break
    f_script = f_script.text
    f_script = f_script[:f_script.find('sections.')]
    all_occurs = re.findall(r'{"type":"text","data":(.*?)}',f_script)


    final_text = ""
    for i in all_occurs:
        final_text = final_text + i[1:-1]

    try:
        headline = sp.select_one('.info__headline').text
    except:
        try:
            headline = sp.select_one('.main-headline').text
        except:
            try:
                headline = sp.find('meta',{'name':'cse_headline'})['content']
            except:
                print(sp.text)
                raise
    headline = headline.replace('  ', '')
    headline = headline.replace('\n', '')


    try:
        timeStamp = sp.find('time').get('datetime')
        timeStamp = timeStamp[:-3] + timeStamp[-2:]
        timeStamp = timeStamp[:-4] + '+0000'
        timeStamp = datetime.datetime.strptime(timeStamp, '%Y-%m-%dT%H:%M:%S%z')
        timeStamp = int(timeStamp.astimezone(pytz.timezone("UTC")).timestamp())
    except:
        try:
            timeStamp = sp.find('meta',{'property':'article:published_time'})['content']
            timeStamp = datetime.datetime.strptime(timeStamp[:-3]+'00', '%Y-%m-%dT%H:%M:%S%z')
            timeStamp = int(timeStamp.astimezone(pytz.timezone("UTC")).timestamp())
        except:
            raise

    


    try:
        ids = (int(eachLink[eachLink.find('article/')+8:eachLink.rfind('/')]))
    except:
        try:
            ids = (int(eachLink[eachLink.rfind('/')+1:]))
        except:
            try:
                idOnsource = eachLink[eachLink.find('article/')+8:]
                idOnsource = idOnsource[:idOnsource.find('/')]
                ids = (int(idOnsource))
            except:
                pass


    authors = []
    try:
        for author in sp.find('div', {"class" : "main-info__names"}).findAll('a'):
            author = author.text
            author = author.replace('  ','')
            author = author.replace('\n','')
            authors.append(author)
    except Exception as e:
        try:
            for author in sp.find('div', {"class" : "article-author__names"}).findAll('a'):
                author = author.text
                author = author.replace('  ','')
                author = author.replace('\n','')
                authors.append(author)
        except:
            author = ''
            pass

    # print(headline)
    # print(final_text[2:])
    # print(timeStamp)
    # print(ids)
    ids_hash = elasticId.generate(ids)
    # print(authors)

    try:
        ret = filterv2.filter(final_text[2:])
    except:
        print("hereis what",eachLink)
        raise Exception(traceback.format_exc())
    if ret == False:
        return False
    data_dict = {
          'headline': headline,
          'main_article': final_text[2:],
          'published_timestamp': timeStamp,
          'source_url': eachLink,
          'source': "South China Morning Post",
          'ISIN': "NULL",
          'sector': ret['sector_list'],
          'category': "NULL",
          'author': authors,
          'stock_symbol': "NULL",
          'debt_listing': ret['debt_listing_list'],
          'id_on_source': ids,
          'sentiment': 'NULL',
          'industry': ret['industry_list'],
          'company_name': ret['company_list'],
          'source_language': "English",
          'entity_id': ret['entity_id_list'],
          'tags': ret['tags'],
          'tags_common': ret['tags_common'],
          'article_desc': '',
          'r': ret['r'],
          'n': ret['n'],
          'ns':ret['ns'],
          'nss': ret['nss'],
          'ta': ret['ta'],
          'country': ret['country'],
          'usd_sales': ret['usd_sales']
        }

    if(len(data_dict["main_article"])>260):
        loc=data_dict["main_article"].find(' ',250,260)
        if(loc!=-1):
            data_dict['article_desc']=data_dict["main_article"][0:loc]
        else:
            data_dict['article_desc']=data_dict["main_article"][0:250]
    else:
        data_dict['article_desc']=data_dict["main_article"]

    return data_dict, ids_hash

# p = elastic_data_dict('https://www.scmp.com/tech/big-tech/article/3107250/samsung-succession-plans-complicated-lee-jae-yongs-risk-jail-time')
# print(p)


