from bs4 import BeautifulSoup as bs
import requests, re, datetime, pytz, time
from v3_filter import filterv2
from v3_elasticId_gen import elasticId
import traceback
from v3_proxies import proxies
import json
from nested_lookup import nested_lookup
import datetime

def elastic_data_dict(eachLink):
    skipList = ['/showbiz/','/travel/','/entertainment/','/lifeandstyle/','/pictures/','/videos/','/tv-and-radio/','/video/','/games/','/picture/','/football/','/artanddesign/','/music/','/sport/','/film/','/food/','/ng-interactive/','/gallery/']
    if any(word in eachLink for word in skipList):
        return False
    headers = {
        'dnt': "1",
        'upgrade-insecure-requests': "1",
        'user-agent': "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.111 Safari/537.36",
        'accept': "text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,image/apng,*/*;q=0.8,application/signed-exchange;v=b3;q=0.9",
        'cache-control': "no-cache"
        }
        
    res = requests.get(eachLink,headers=headers)
    if res.status_code in [403,500,502]:
        res = proxies.try_proxy(eachLink,headers)
    if res.status_code in [404]:
        return False
    soup = bs(res.content,'html5lib')
    with open(f'theguardian.txt','wb') as f:
        f.write((eachLink+'\n').encode('utf-8'))
        f.write(res.content)
    headline = soup.find('meta',{'property':'og:title'})['content']
    try:
        timeStamp = soup.find('meta',{'property':'article:published_time'})['content']
        timeStamp = timeStamp.split('.')[0]
        timeStamp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%dT%H:%M:%S%z')
        timeStamp = int(timeStamp.astimezone(pytz.timezone("UTC")).timestamp())
    except:
        timeStamp = int(soup.find('time',{'itemprop':'datePublished'})['data-timestamp'])/1000
    
    try:
        authors = soup.find('meta',{'property':'article:author'})['content']
    except:
        authors = ''
    try:
        articleBody = soup.find('div',{'class':'content__article-body'})
        if articleBody is None:
            articleBody = soup.find('div',{'class':'article-body-commercial-selector'})
        
        if articleBody is None:
            articleBody = soup.find('div',{'class':'content__main-column'})
        articleBody = articleBody.find_all('p')
        articleBody = [i.text for i in articleBody]
        articleBody = "\n".join(articleBody)
    except AttributeError:
        articleBody = soup.find_all('script',{'type':'application/ld+json'})[-1]
        articleBody = json.loads(articleBody.contents[0])
        articleBody = [i['articleBody'] for i in articleBody['liveBlogUpdate'][0]]
        articleBody = '\n'.join(articleBody)



    ids = eachLink
    ids_hash = elasticId.generate(ids)
    # print(authors)

    try:
        ret = filterv2.filter(articleBody)
    except:
        print("hereis what",eachLink)
        raise Exception(traceback.format_exc())
    if ret == False:
        return False
    
    
    data_dict = {
          'headline': headline,
          'main_article': articleBody,
          'published_timestamp': timeStamp,
          'source_url': eachLink,
          'source': "The Guardian",
          'ISIN': "NULL",
          'sector': ret['sector_list'],
          'category': "NULL",
          'author': authors,
          'stock_symbol': "NULL",
          'debt_listing': ret['debt_listing_list'],
          'id_on_source': ids,
          'sentiment': 'NULL',
          'industry': ret['industry_list'],
          'company_name': ret['company_list'],
          'source_language': "English",
          'entity_id': ret['entity_id_list'],
          'tags': ret['tags'],
          'tags_common': ret['tags_common'],
          'article_desc': '',
          'r': ret['r'],
          'n': ret['n'],
          'ns':ret['ns'],
          'nss': ret['nss'],
          'ta': ret['ta'],
          'country': ret['country'],
          'usd_sales': ret['usd_sales']
        }

    if(len(data_dict["main_article"])>260):
        loc=data_dict["main_article"].find(' ',250,260)
        if(loc!=-1):
            data_dict['article_desc']=data_dict["main_article"][0:loc]
        else:
            data_dict['article_desc']=data_dict["main_article"][0:250]
    else:
        data_dict['article_desc']=data_dict["main_article"]

    return data_dict, ids_hash

# p = elastic_data_dict('https://www.theguardian.com/politics/live/2020/oct/29/uk-politics-live-ehrc-to-publish-report-into-labour-and-antisemitism')
# print(p)


