from bs4 import BeautifulSoup as bs
import requests, re, datetime, pytz, time
from v3_filter import filterv2
from v3_elasticId_gen import elasticId
import traceback
from v3_proxies import proxies
import json
from nested_lookup import nested_lookup
import datetime



def elastic_data_dict(eachLink):
    skipList = ['/photo/','/video/','/life/','/sports/','/travel/']
    if any(word in eachLink for word in skipList):
        return False

    headers={"accept":"*/*",
        "accept-encoding":"gzip, deflate, br",
        "accept-language":"en-GB,en-US;q=0.9,en;q=0.8",
        "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/86.0.4240.193 Safari/537.36"
        }
    
    res = requests.get(eachLink)
    if res.status_code in [403,500,502]:
        res = proxies.try_proxy(eachLink,headers)
    if res.status_code in [404]:
        return False
    sp = bs(res.content,'html5lib')
    with open(f'vnexpress.txt','wb') as f:
        f.write((eachLink+'\n').encode('utf-8'))
        f.write(res.content)
    
    headline = sp.find('h1', class_ = 'title_post').get_text()
    author = sp.find('div', class_ = 'author').a.get_text()
    ids = eachLink.split('-')[-1].split('.')[0]
    detail = sp.find('h2', class_ = 'lead_post_detail row').get_text()
    body = sp.findAll('p', class_ = 'Normal')
    body = ' '.join([para.get_text() for para in body]).replace('\xa0',' ')
    body = detail + body
    tags = sp.findAll('h4', class_ = 'tag_item')
    tags = ', '.join([tag.get_text().replace('\n', '').replace('\t',' ') for tag in tags])
    
    publisted_date = sp.find('div', class_ = 'author').get_text().split('\xa0')[-1].replace('\t','').replace('\n','')
    timeStamp = datetime.datetime.strptime(publisted_date.replace('GMT+7','+0700'), '%B %d, %Y | %I:%M %p %z').timestamp()

    ids_hash = elasticId.generate(ids)

    try:
        ret = filterv2.filter(body)
    except:
        print("hereis what",eachLink)
        raise Exception(traceback.format_exc())
    if ret == False:
        return False
    
    data_dict = {
          'headline': headline,
          'main_article': body,
          'published_timestamp': timeStamp,
          'source_url': eachLink,
          'source': "Vn Express",
          'ISIN': "NULL",
          'sector': ret['sector_list'],
          'category': "NULL",
          'author': author,
          'stock_symbol': "NULL",
          'debt_listing': ret['debt_listing_list'],
          'id_on_source': ids,
          'sentiment': 'NULL',
          'industry': ret['industry_list'],
          'company_name': ret['company_list'],
          'source_language': "English",
          'source_tags':tags,
          'entity_id': ret['entity_id_list'],
          'tags': ret['tags'],
          'tags_common': ret['tags_common'],
          'article_desc': '',
          'r': ret['r'],
          'n': ret['n'],
          'ns':ret['ns'],
          'nss': ret['nss'],
          'ta': ret['ta'],
          'country': ret['country'],
          'usd_sales': ret['usd_sales']
        }

    if(len(data_dict["main_article"])>260):
        loc=data_dict["main_article"].find(' ',250,260)
        if(loc!=-1):
            data_dict['article_desc']=data_dict["main_article"][0:loc]
        else:
            data_dict['article_desc']=data_dict["main_article"][0:250]
    else:
        data_dict['article_desc']=data_dict["main_article"]

    return data_dict, ids_hash
