from bs4 import BeautifulSoup as bs
import requests
import datetime
import pytz
import time

def xml_parser(res_content,previous_ts):
    soup = bs(res_content,'lxml')
    total_urls = []
    latest_times = previous_ts
    for i in soup.find_all("url"):
        u = i.find('loc').text
        timeStamp = get_timestamp(i)
        timeStamp = int(timeStamp.astimezone(pytz.timezone("UTC")).timestamp())
        
        if timeStamp >= previous_ts:
            if timeStamp >= latest_times:
                latest_times = timeStamp
            total_urls.append(u)


    # d = datetime.datetime.utcnow()
    # epoch = datetime.datetime(1970,1,1)
    # t = (d - epoch).total_seconds()

    return total_urls, int(latest_times)
    
def get_timestamp(i):
    try:
        timeStamp = i.find('lastmod').text
        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp, '%Y-%m-%dT%H:%M:%SZ%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%dT%H:%MZ%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%dT%H:%M:%SZ%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = timeStamp[:-3] + timeStamp.split(":")[-1]
            timeStamp_temp = datetime.datetime.strptime(timeStamp, '%Y-%m-%dT%H:%M:%S%z')
            return timeStamp_temp
        except:
            pass
    except:
        timeStamp = i.find('news:publication_date').text
        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp, '%Y-%m-%dT%H:%M:%SZ%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%dT%H:%MZ%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%dT%H:%M:%SZ%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = timeStamp[:-3] + timeStamp.split(":")[-1]
            timeStamp_temp = datetime.datetime.strptime(timeStamp, '%Y-%m-%dT%H:%M:%S%z')
            return timeStamp_temp
        except:
            pass

        try:
            timeStamp_temp = datetime.datetime.strptime(timeStamp+'+0000', '%Y-%m-%d%z')
            return timeStamp_temp
        except:
            pass

        print(timeStamp)


            

def url_parser(site_stamp):
    site_stamp = site_stamp.replace('year',str(time.localtime().tm_year))
    # site_stamp = site_stamp.replace('month',str(time.localtime().tm_mon))
    dayOnStamp = '0' + str(time.localtime().tm_mday)
    dayOnStamp = dayOnStamp[-2:]
    site_stamp = site_stamp.replace('day',dayOnStamp)
    monOnStamp = '0' + str(time.localtime().tm_mon)
    monOnStamp = monOnStamp[-2:]
    site_stamp = site_stamp.replace('month',monOnStamp)
    return site_stamp

    

    

